//**************************************************************************
//*                     This file is part of the                           *
//*                      Mpxplay - audio player.                           *
//*                  The source code of Mpxplay is                         *
//*        (C) copyright 1998-2005 by PDSoft (Attila Padar)                *
//*                    http://mpxplay.cjb.net                              *
//*                  email: mpxplay@freemail.hu                            *
//**************************************************************************
//*  This program is distributed in the hope that it will be useful,       *
//*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
//*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
//*  Please contact with the author (with me) if you want to use           *
//*  or modify this source.                                                *
//**************************************************************************
//function: rest of newfuncs

#include <stdlib.h>
#include "newfunc.h"

extern unsigned int iswin9x;
extern dosmem_t dm_int2x_1;

unsigned long pds_rand(int maxnum)
{
#ifdef __DOS__
 unsigned int i;
 char *biosmem;
#endif
 unsigned int r;

 if(maxnum<1)
  return 0;
#ifdef __DOS__
 r=0;
 biosmem=(char *)0;
 for(i=(biosmem[0x46c]&127);i;i--)
  r+=(biosmem[0x046c]);
 r+=rand();
#else
 r=rand()*rand()*rand();
#endif
 return (r%maxnum);
}

//--------------------------------------------------------------------------
void pds_setapplicationtitle(char *title)
{
#ifdef __DOS__
 if(iswin9x && !pds_filehand_check_infilehand()){
  struct rminfo RMI;
  pds_dpmi_rmi_clear(&RMI);
  RMI.EAX=0x0000168E;
  RMI.ECX=80;
  RMI.ES =dm_int2x_1.segment;
  pds_strcpy(dm_int2x_1.linearptr,title);
  pds_dpmi_realmodeint_call(0x2f,&RMI);
 }
#endif
}

//--------------------------------------------------------------------------
// FPU settings
void asm_fpu_setround_near(void);

void pds_fpu_setround_near(void)
{
 unsigned short controlword;
#ifdef __WATCOMC__
 #pragma aux asm_fpu_setround_near=\
  "fstcw word ptr controlword"\
  "and word ptr controlword,0xf3ff"\
  "fldcw word ptr controlword"\
  modify[];
 asm_fpu_setround_near();
#endif
}

void asm_fpu_setround_chop(void);

void pds_fpu_setround_chop(void)
{
 unsigned short controlword;
#ifdef __WATCOMC__
 #pragma aux asm_fpu_setround_chop=\
  "fstcw word ptr controlword"\
  "or word ptr controlword,0x0c00"\
  "fldcw word ptr controlword"\
  modify[];
 asm_fpu_setround_chop();
#endif
}

//--------------------------------------------------------------------------
//shutdown routine
void asm_disk_reset(void);
void asm_apm_shutdown(void);

void pds_shutdown_atx(void)
{
#ifdef __DOS__
 if(iswin9x){
  //system("rundll32.exe User,ExitWindows");
  system("rundll32.exe shell32.dll,SHExitWindowsEx 5");
 }else{
  //1.disks reset
  //2.reset disk system
 #ifdef __WATCOMC__
  #pragma aux asm_disk_reset=\
  "mov ax,0x0d00"\
  "int 0x21"\
  "xor eax,eax"\
  "mov dx,128"\
  "int 0x13"\
  modify[eax edx];
  asm_disk_reset(); // flush caches and reset disks

  //1.RealMode Interface connect
  //2.Engage power management
  //3.Enable APM for all devices
  //4.Force version 1.1 compatibility
  //5 First attempt: using APM 1.1 or later
  //  Shutdown all the devices supported by APM
  //6.Second attempt: using APM 1.0
  //  Shutdown only the system BIOS
  #pragma aux asm_apm_shutdown=\
  "mov ax,0x5301"\
  "mov bx,0"\
  "int 0x15"\
  "mov ax,0x530f"\
  "mov bx,1"\
  "mov cx,1"\
  "int 0x15"\
  "mov ax,0x5308"\
  "mov bx,1"\
  "mov cx,1"\
  "int 0x15"\
  "mov ax,0x530e"\
  "mov bx,0"\
  "mov cx,0x0101"\
  "int 0x15"\
  "mov ax,0x5307"\
  "mov bx,1"\
  "mov cx,3"\
  "int 0x15"\
  "mov ax,0x5307"\
  "mov bx,0"\
  "mov cx,3"\
  "int 0x15"\
  modify[eax ebx ecx];
  asm_apm_shutdown(); // shutdown by advanced power managment (BIOS)
 #endif
 }
#endif
}
