//**************************************************************************
//*                     This file is part of the                           *
//*                      Mpxplay - audio player.                           *
//*                  The source code of Mpxplay is                         *
//*        (C) copyright 1998-2005 by PDSoft (Attila Padar)                *
//*                    http://mpxplay.cjb.net                              *
//*                  email: mpxplay@freemail.hu                            *
//**************************************************************************
//*  This program is distributed in the hope that it will be useful,       *
//*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
//*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
//*  Please contact with the author (with me) if you want to use           *
//*  or modify this source.                                                *
//**************************************************************************
//function: newfunc (stuffs) main

#include "newfunc.h"
#include "dll_load.h"
#include "mpxplay.h"

extern unsigned int oldposrow,intsoundconfig,intsoundcontrol;

char DOS4GOPTIONS[] = "dos4g=StartupBanner:OFF\n"; // for DOS4G v2.01

//-------------------------------------------------------------------------
//newfunc init & close

void newfunc_init(char *prgname)
{
 newfunc_memory_init();
 newfunc_error_handlers_init();

#ifdef __DOS__
 if(!pds_int2x_dosmems_allocate())
  mpxplay_close_program(MPXERROR_CONVENTIONAL_MEM);

 pds_indosflag_init();
 pds_check_lfnapi(prgname);
#endif // __DOS__

 newfunc_textdisplay_init();
 oldposrow=pds_textdisplay_getcursor_y();
}

void newfunc_close(void)
{
 newfunc_dllload_closeall();
 newfunc_newhandler08_close();
#ifdef __DOS__
 pds_int2x_dosmems_free();
#endif
 newfunc_textdisplay_close();
}

//-------------------------------------------------------------------
//newfunc API for DLLs

#include "control\control.h"

extern mainvars mvps;

struct mpxplay_resource_s mpxplay_resources={
 &mvps,                          // 0.
 NULL,
 &intsoundconfig,
 &intsoundcontrol,
 0,
 0,
 0,
 0,
 0,
 0,

 //dpmi.c
 &pds_dpmi_getrmvect,            // 10.
 &pds_dpmi_setrmvect,
 &pds_dpmi_getexcvect,
 &pds_dpmi_setexcvect,
 &pds_dos_getvect,
 &pds_dos_setvect,
 &pds_dpmi_dos_allocmem,
 &pds_dpmi_dos_freemem,
 &pds_dpmi_realmodeint_call,
 NULL,

 //drivehnd.c
 &pds_fullpath,                  // 20.
 &pds_getcwd,
 &pds_getdcwd,
 &pds_chdir,
 &pds_mkdir,
 &pds_rmdir,
 &pds_rename,
 &pds_unlink,
 &pds_findfirst,
 &pds_findnext,
 &pds_findclose,                 // 30.
 &pds_truename_dos,
 &pds_getdrive,
 &pds_setdrive,
 &pds_drivesinfo,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,

 //filehand.c
 &pds_open_read,                 // 40.
 &pds_open_write,
 &pds_open_create,
 &pds_dos_read,
 &pds_dos_write,
 &pds_close,
 &pds_lseek,
 &pds_tell,
 &pds_eof,
 &pds_filelength,
 &pds_chsize,                    // 50.
 &pds_fopen,
 NULL,
 NULL,
 NULL,
 &pds_copyfile,
 NULL,
 NULL,
 NULL,
 NULL,

 //keyboard.c
 &pds_kbhit,                     // 60.
 &pds_extgetch,
 &pds_look_extgetch,
 &pds_pushkey,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,

 //memory.c
 &pds_memcpy,                    // 70.
 &pds_memset,
 &pds_qmemreset,
 &pds_qmemcpy,
 &pds_qmemcpyr,
 &pds_memxch,
 &pds_malloc,
 &pds_calloc,
 &pds_realloc,
 &pds_free,

 //string.c
 &pds_strcpy,                    // 80.
 &pds_strncpy,
 &pds_strcat,
 &pds_strcmp,
 &pds_stricmp,
 &pds_strricmp,
 &pds_strlicmp,
 &pds_strncmp,
 &pds_strnicmp,
 &pds_strlen,
 &pds_strlenc,                   //  90.
 &pds_strchr,
 &pds_strrchr,
 &pds_strstri,
 &pds_strcutspc,
 &pds_ltoa,
 NULL, //&pds_ltoa16,
 &pds_atol,
 &pds_atol16,
 &pds_getfilename_from_fullname,
 &pds_getfilename_noext_from_fullname, // 100.
 &pds_getpath_from_fullname,
 &pds_getdrivenum_from_path,
 &pds_fullpath_check,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,

 //textdisp.c
 &pds_textdisplay_charxy,        // 110.
 &pds_textdisplay_textxy,
 &pds_textdisplay_clrscr,
 &pds_textdisplay_scrollup,
 &pds_textdisplay_printf,
 &pds_textdisplay_getbkcolorxy,
 &pds_textdisplay_setcolorxy,
 &pds_textdisplay_setbkcolorxy,
 &pds_textdisplay_spacecxyn,
 &pds_textdisplay_vidmem_save,
 &pds_textdisplay_vidmem_restore,// 120.
 &pds_textdisplay_setresolution,
 &pds_textdisplay_getresolution,
 &pds_textdisplay_getcursor_y,
 &pds_textdisplay_gotoxy,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,

 //time.c
 &pds_gettimeh,                  // 130.
 &pds_gettime,
 &pds_getdate,
 &pds_strtime_to_hextime,
 &pds_strtime_to_hexhtime,
 &pds_delay_10us,
 NULL,
 NULL,
 NULL,
 NULL,

 //timer.c
 &mpxplay_timer_secs_to_counternum, //140.
 &mpxplay_timer_addfunc,
 &mpxplay_timer_modifyfunc,
 &mpxplay_timer_deletefunc,
 &mpxplay_timer_deletehandler,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL                            // 149.

};
